Hybrid Graphics and general enablement for fglrx and nvidia in Precise for 12.04.3

Bug #1198942 reported by Alberto Milone on 2013-07-08
56
This bug affects 10 people
Affects Status Importance Assigned to Milestone
fglrx-installer-updates (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
fglrx-pxpress (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
jockey (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-graphics-drivers-173-updates (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-graphics-drivers-304 (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-graphics-drivers-304-updates (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-graphics-drivers-319 (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-graphics-drivers-319-updates (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned
nvidia-prime (Ubuntu)
High
Alberto Milone
Precise
Undecided
Unassigned

Bug Description

SRU request:

As per the topic, the purpose of this report is to make sure that users get graphics drivers that work with Raring's X/Kernel in Precise 12.04.3.

This work also enables support for Hybrid graphics (as planned) and requires changes in Jockey in addition to the drivers.

This SRU involves the following packages

jockey
nvidia-prime
fglrx-pxpress
nvidia-graphics-drivers-319
nvidia-graphics-drivers-319-updates
nvidia-graphics-drivers-304
nvidia-graphics-drivers-304-updates
nvidia-graphics-drivers-173-updates
nvidia-settings-319
nvidia-settings-319-updates
nvidia-settings-304
nvidia-settings-304-updates
nvidia-persistenced
fglrx-installer-updates
fglrx-installer-experimental-13

Only jockey, nvidia-graphics-drivers-173-updates and fglrx-installer-updates already existed in the archive, the rest is in NEW.

The changes in jockey are all documented in jockey's changelog. I added tests in the test suite to make sure that we simulate hybrid graphics systems (using fake devices) and test the relevant code paths.

In short, we don't provide graphics drivers on unsupported systems with hybrid graphics, thus preventing users from breaking their systems. When hybrid graphics is available and supported (i.e. there is a driver which supports it and the Raring stack is installed) not only do we provide the drivers, we also take care of installing either fglrx-pxpress or nvidia-prime, which will take care of any required configuration so that, on next boot, things will work with no user interaction. Quite an improvement compared with a certain xserver failure in case of a misconfigured or unsupported system.

As for the drivers, they all work with kernels up to 3.10 and include the following features:
 * NVIDIA's 319 series add support for hybrid graphics, in addition to being a LTS series. They also replace any experimental driver we uploaded.
 * current users of nvidia-current and nvidia-current-updates will be migrated to nvidia-304 and nvidia-304-updates (same driver release, only different name).
 * All (obsolete) experimental nvidia drivers will be migrated to nvidia-319-updates.
 * fglrx-updates will be updated to the latest stable release.
 * fglrx-experimental-13 will replace all experimental releases and add stable support for hybrid graphics.
 * nvidia-persistenced is a daemon (only for the 319 series) which, by default, preserves the standard behaviour of the nvidia driver. It makes it easier for users to enable persistence mode to work around bugs in the driver (e.g. LP: #1202152)

Changed in nvidia-graphics-drivers-319 (Ubuntu):
status: New → In Progress
assignee: nobody → Alberto Milone (albertomilone)
importance: Undecided → High
milestone: none → ubuntu-12.04.3
Changed in nvidia-graphics-drivers-173 (Ubuntu):
status: New → In Progress
Changed in nvidia-graphics-drivers-304 (Ubuntu):
status: New → In Progress
Changed in nvidia-graphics-drivers-304-updates (Ubuntu):
status: New → In Progress
Changed in nvidia-graphics-drivers-319-updates (Ubuntu):
status: New → In Progress
dino99 (9d9) wrote :

Jockey has been superseded by software-properties, which now handles
third-party driver configuration.

So all the active ubuntu releases might now only use software-properties; and jockey removed from the archive (as i understand the actual ubuntu built).

bugbot (bugbot) on 2013-07-11
tags: added: precise
Changed in jockey (Ubuntu):
status: New → Triaged
assignee: nobody → Alberto Milone (albertomilone)
Changed in nvidia-graphics-drivers-173 (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Changed in nvidia-graphics-drivers-304 (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Changed in nvidia-graphics-drivers-304-updates (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Changed in nvidia-graphics-drivers-319-updates (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Changed in fglrx-installer-updates (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
status: New → Triaged
affects: nvidia-graphics-drivers-173 (Ubuntu) → nvidia-graphics-drivers-173-updates (Ubuntu)
Changed in fglrx-installer-updates (Ubuntu):
importance: Undecided → High
Changed in jockey (Ubuntu):
importance: Undecided → High
Changed in nvidia-graphics-drivers-173-updates (Ubuntu):
importance: Undecided → High
Changed in nvidia-graphics-drivers-304 (Ubuntu):
importance: Undecided → High
Changed in nvidia-graphics-drivers-304-updates (Ubuntu):
importance: Undecided → High
Changed in nvidia-graphics-drivers-319-updates (Ubuntu):
importance: Undecided → High
Changed in fglrx-installer-updates (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in fglrx-pxpress (Ubuntu):
milestone: none → ubuntu-12.04.3
importance: Undecided → High
status: New → Triaged
Changed in jockey (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in nvidia-graphics-drivers-173-updates (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in nvidia-graphics-drivers-304 (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in nvidia-graphics-drivers-304-updates (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in nvidia-graphics-drivers-319-updates (Ubuntu):
milestone: none → ubuntu-12.04.3
Changed in nvidia-prime (Ubuntu):
milestone: none → ubuntu-12.04.3
importance: Undecided → High
assignee: nobody → Alberto Milone (albertomilone)
status: New → Triaged
Changed in fglrx-installer-updates (Ubuntu):
status: Triaged → In Progress
summary: - Backport fglrx and nvidia binary drivers to Precise for 12.04.3
+ Hybrid Graphics enablement for fglrx and nvidia in Precise for 12.04.3
summary: - Hybrid Graphics enablement for fglrx and nvidia in Precise for 12.04.3
+ Hybrid Graphics and general enablement for fglrx and nvidia in Precise
+ for 12.04.3
description: updated
tags: added: hwe
tags: removed: hwe
Alberto Milone (albertomilone) wrote :

tha packages are pending approval in precise-proposed

Changed in nvidia-prime (Ubuntu):
status: Triaged → In Progress
Changed in fglrx-pxpress (Ubuntu):
status: Triaged → In Progress
Changed in jockey (Ubuntu):
status: Triaged → In Progress
Changed in fglrx-pxpress (Ubuntu):
assignee: nobody → Alberto Milone (albertomilone)
Steve Langasek (vorlon) on 2013-08-09
Changed in fglrx-installer-updates (Ubuntu):
status: In Progress → Fix Released
Changed in fglrx-installer-updates (Ubuntu Precise):
status: New → Fix Committed
status: Fix Committed → In Progress
Changed in fglrx-pxpress (Ubuntu):
status: In Progress → Fix Released
Changed in fglrx-pxpress (Ubuntu Precise):
status: New → Fix Committed
Changed in jockey (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-graphics-drivers-173-updates (Ubuntu):
status: In Progress → Fix Released
Steve Langasek (vorlon) on 2013-08-09
Changed in nvidia-graphics-drivers-304 (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-graphics-drivers-304 (Ubuntu Precise):
status: New → Fix Committed
Changed in nvidia-graphics-drivers-304-updates (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-graphics-drivers-304-updates (Ubuntu Precise):
status: New → Fix Committed
Changed in nvidia-graphics-drivers-319 (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-graphics-drivers-319 (Ubuntu Precise):
status: New → Fix Committed
Changed in nvidia-graphics-drivers-319-updates (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-graphics-drivers-319-updates (Ubuntu Precise):
status: New → Fix Committed
Changed in nvidia-prime (Ubuntu):
status: In Progress → Fix Released
Changed in nvidia-prime (Ubuntu Precise):
status: New → Fix Committed
Steve Langasek (vorlon) on 2013-08-09
Changed in fglrx-installer-updates (Ubuntu Precise):
status: In Progress → Fix Committed

Hello Alberto, or anyone else affected,

Accepted nvidia-graphics-drivers-173-updates into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/nvidia-graphics-drivers-173-updates/173.14.37-0ubuntu0.0.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in nvidia-graphics-drivers-173-updates (Ubuntu Precise):
status: New → Fix Committed
tags: added: verification-needed
Steve Langasek (vorlon) wrote :

Hello Alberto, or anyone else affected,

Accepted jockey into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/jockey/0.9.7-0ubuntu7.10 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in jockey (Ubuntu Precise):
status: New → Fix Committed
Timo Aaltonen (tjaalton) wrote :

tested on Thinkpad T420s with intel+nvidia hybrid on precise with raring stack, seems to work like on saucy

tags: added: verification-done
removed: verification-needed
Adam Conrad (adconrad) wrote :

Hello Alberto, or anyone else affected,

Accepted fglrx-installer-experimental-13 into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/fglrx-installer-experimental-13/2:13.101-0ubuntu0.0.2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: removed: verification-done
tags: added: verification-needed
Alberto Milone (albertomilone) wrote :

I tested fglrx-installer-experimental-13 (2:13.101-0ubuntu0.0.2) and fglrx-pxpress with and without jockey on my Dell Inspiron N4110 and they worked without problems. Thanks to PowerXpress I can use the discrete card.

I also tested nvidia-319 and nvidia-319-updates (one at a time) together with nvidia-prime (with and without jockey) on my Lenovo L480S. It all works correctly with Hybrid graphics.

I haven't experienced any regressions with systems with a single GPU (e.g. my Inspiron 1122). All drivers show up and install correctly. Neither nvidia-prime nor fglrx-pxpress is installed in this case (as expected).

Also, using stacks older than Raring's (lts-raring), no drivers show up on systems with hybrid graphics, as expected.

tags: added: verification-done
removed: verification-needed
Alberto Milone (albertomilone) wrote :

I forgot to mention that I also tested the other nvidia drivers and I didn't spot any issues

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-graphics-drivers-319 - 319.32-0ubuntu0.0.1

---------------
nvidia-graphics-drivers-319 (319.32-0ubuntu0.0.1) precise-proposed; urgency=low

  * Initial release (LP: #1198942).
 -- Alberto Milone <email address hidden> Mon, 08 Jul 2013 15:27:23 +0200

Changed in nvidia-graphics-drivers-319 (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-graphics-drivers-304-updates - 304.88-0ubuntu0.0.3

---------------
nvidia-graphics-drivers-304-updates (304.88-0ubuntu0.0.3) precise-proposed; urgency=low

  * Initial release (LP: #1198942).
  * Start with 304.88-0ubuntu0.0.3 so that transitional packages work.
 -- Alberto Milone <email address hidden> Mon, 08 Jul 2013 15:50:52 +0200

Changed in nvidia-graphics-drivers-304-updates (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-graphics-drivers-304 - 304.88-0ubuntu0.0.3

---------------
nvidia-graphics-drivers-304 (304.88-0ubuntu0.0.3) precise-proposed; urgency=low

  * Initial release (LP: #1198942).
  * Starting with -0ubuntu0.0.3 so that transitional packages work.
 -- Alberto Milone <email address hidden> Mon, 08 Jul 2013 15:40:19 +0200

Changed in nvidia-graphics-drivers-304 (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-graphics-drivers-319-updates - 319.32-0ubuntu0.0.1

---------------
nvidia-graphics-drivers-319-updates (319.32-0ubuntu0.0.1) precise-proposed; urgency=low

  * Initial release (LP: #1198942).
 -- Alberto Milone <email address hidden> Mon, 08 Jul 2013 15:28:28 +0200

Changed in nvidia-graphics-drivers-319-updates (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package fglrx-pxpress - 0.3~hybrid0.0.1

---------------
fglrx-pxpress (0.3~hybrid0.0.1) precise; urgency=low

  * Initial release (LP: #1198942).
 -- Alberto Milone <email address hidden> Tue, 23 Jul 2013 15:20:46 +0200

Changed in fglrx-pxpress (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-prime - 0.3~hybrid0.0.1

---------------
nvidia-prime (0.3~hybrid0.0.1) precise; urgency=low

  * Initial release (LP: #1198942).
 -- Alberto Milone <email address hidden> Wed, 24 Jul 2013 10:51:32 +0200

Changed in nvidia-prime (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package jockey - 0.9.7-0ubuntu7.10

---------------
jockey (0.9.7-0ubuntu7.10) precise-proposed; urgency=low

  * data/handlers/fglrx.py:
    - Show the driver as enabled when pxpress is in use.
      Thanks to Doro Wu for the patch (LP: #1196848).
    - Add handlers for -experimental-{12|13}.
    - Only -experimental-13 supports hybrid graphics.
  * data/handlers/nvidia.py:
    - Add handlers for 319/-updates 304/-updates.
    - Only 319/-updates support hybrid graphics.
    - Make sure to remove the correct nvidia-settings
      flavour.
  * data/handlers/{fglrx|nvidia}.py:
    - Add support for Hybrid Graphics (LP: #1198942):
      + Driver handlers now need to state that they support
        hybrid graphics and subclass either the
        _NvidiaDriverHybridBase class or the FglrxDriverHybrid
        class.
      + Drivers which don't claim to support hybrid graphics
        will not show up on hybrid systems.
      + If the nvidia-prime or the fglrx-pxpress packages are
        not available, the drivers won't be available on
        hybrid systems. This avoids breaking systems which
        require further configuration which only these two
        packages provide.
      + Jockey doesn't touch the xorg.conf when dealing with
        hybrid graphics (as either nvidia-prime or
        fglrx-pxpress will take care of it).
      + Hybrid Graphics is only supported on systems which
        use Raring's backported X and kernel.
  * jockey/xorg_driver.py:
    - Add supports_hybrid_graphics class attribute.
    - Add has_hybrid_graphics class attribute.
    - Add better support for faking devices and packages.
    - Ignore transitional packages.
  * jockey/oslib.py:
    - Add package_transitional() method.
    - Add package_available() method.
    - Make current_xorg_video_abi take into account
      backported packages.
    - Catch additional arguments in package_installed().
      This gives us some flexibility when using fake
      devices for testing.
    - Add some checks for raring's backported xserver.
  * tests/hybridgraphics.py:
    - Add coverage for hybrid graphics.
  * tests/oslib.py:
    - Deal with the multiple video abis that drivers may
      support.
    - Make sure that the kernel headers are available before
      failing.
  * tests/sandbox.py:
    - Report a more compliant fake X ABI.
    - Update package_installed() to match the one in oslib.py.
 -- Alberto Milone <email address hidden> Fri, 26 Jul 2013 10:38:06 +0200

Changed in jockey (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nvidia-graphics-drivers-173-updates - 173.14.37-0ubuntu0.0.1

---------------
nvidia-graphics-drivers-173-updates (173.14.37-0ubuntu0.0.1) precise-proposed; urgency=low

  * New upstream release:
    - Added support for xserver ABI 14 (xorg-server 1.14).
  * debian/control.in:
    - Remove the dependency on the linux headers as with other
      drivers.
    - Recommend nvidia-settings-304-updates.
    - Add ${misc:Depends}.
  * debian/substvars:
    - Add an alternative dependency on xserver-xorg-core-lts-raring.
      (LP: #1198942).
  * Add support for Linux 3.10.
 -- Alberto Milone <email address hidden> Fri, 12 Jul 2013 11:12:01 +0200

Changed in nvidia-graphics-drivers-173-updates (Ubuntu Precise):
status: Fix Committed → Fix Released
dino99 (9d9) on 2015-09-12
Changed in fglrx-installer-updates (Ubuntu Precise):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers